declare class MouseEvents {
    /**
     * The event occurs when the user clicks on an element.
     *
     * @property CLICK
     * @type {string}
     * @static
     */
    static CLICK: string;
    /**
     * The event occurs when the user double-clicks on an element.
     *
     * @property DBL_CLICK
     * @type {string}
     * @static
     */
    static DBL_CLICK: string;
    /**
     * The event occurs when a user presses a mouse button over an element.
     *
     * @property MOUSE_DOWN
     * @type {string}
     * @static
     */
    static MOUSE_DOWN: string;
    /**
     * The event occurs when the pointer is moving while it is over an element.
     *
     * @property MOUSE_MOVE
     * @type {string}
     * @static
     */
    static MOUSE_MOVE: string;
    /**
     * The event occurs when the pointer is moved onto an element.
     *
     * @property MOUSE_OVER
     * @type {string}
     * @static
     */
    static MOUSE_OVER: string;
    /**
     * The event occurs when a user moves the mouse pointer out of an element.
     *
     * @property MOUSE_OUT
     * @type {string}
     * @static
     */
    static MOUSE_OUT: string;
    /**
     * The event occurs when a user releases a mouse button over an element
     *
     * @property MOUSE_UP
     * @type {string}
     * @static
     */
    static MOUSE_UP: string;
    /**
     *
     *
     * @property TAP
     * @type {string}
     * @static
     */
    static TAP: string;
}
export default MouseEvents;
