class MouseEvents
{
    /**
     * The event occurs when the user clicks on an element.
     *
     * @property CLICK
     * @type {string}
     * @static
     */
    public static CLICK:string = 'click';

    /**
     * The event occurs when the user double-clicks on an element.
     *
     * @property DBL_CLICK
     * @type {string}
     * @static
     */
    public static DBL_CLICK:string = 'dblclick';

    /**
     * The event occurs when a user presses a mouse button over an element.
     *
     * @property MOUSE_DOWN
     * @type {string}
     * @static
     */
    public static MOUSE_DOWN:string = 'mousedown';

    /**
     * The event occurs when the pointer is moving while it is over an element.
     *
     * @property MOUSE_MOVE
     * @type {string}
     * @static
     */
    public static MOUSE_MOVE:string = 'mousemove';

    /**
     * The event occurs when the pointer is moved onto an element.
     *
     * @property MOUSE_OVER
     * @type {string}
     * @static
     */
    public static MOUSE_OVER:string = 'mouseover';

    /**
     * The event occurs when a user moves the mouse pointer out of an element.
     *
     * @property MOUSE_OUT
     * @type {string}
     * @static
     */
    public static MOUSE_OUT:string = 'mouseout';

    /**
     * The event occurs when a user releases a mouse button over an element
     *
     * @property MOUSE_UP
     * @type {string}
     * @static
     */
    public static MOUSE_UP:string = 'mouseup';

    /**
     *
     *
     * @property TAP
     * @type {string}
     * @static
     */
    public static TAP:string = 'tap';
}

export default MouseEvents;